;compile with "ML.EXE /c /Cp /nologo figura.asm
;you need an old dos-compiler
;DOSLNK.EXE /TINY figura.obj
;in some case doslnk.exe is called as link16.exe
;radasm can do this job with their default configuration to ms-dos .com program.

seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	100h
aqui:
big		proc	far
		mov     ax,0003h        ;80x25 video mode
        int     10h

;first line draw
		mov     bx,001eh	;bh == 0, bl = high nibble background color and low nibble face color of char
        mov     cx,0001h	;how many times write it?
        mov     ax,09dah	;ah = show char al == char
        int 10h				;BIOS INT

		mov ah,02			;BIOS FUNCTION SET CURSOR POSITION
		mov dx,0001			;DH = line number (starts from line 0 to colum 24)
							;DL = colum number(starts from colum 0 to colum 79)
		int 10h
        mov     cl,78		;lets draw this color 78 times
        mov     ax,09c4h	;with al char
        int 10h
		mov ah,02
		add dx,cx			;adding it to move cursor to that place
		int 10h
        mov     cl,1
        mov     ax,09bfh	;ending this line with this char
        int 10h
;first line end draw

;second line
mov dx,0100h	;second line colum 0 position cursor
mov ah,02
int 10h
		mov     bx,001eh
        mov     cx,0001h
        mov     ax,09b3h
        int 10h
add dx,cx
mov ah,02
int 10h
		mov     bx,001eh
        mov     cx,0009h
        mov     ax,0920h
        int 10h
add dx,cx
mov ah,02
int 10h
		mov     bx,005fh	;maybe a lodsb with loop can be better
        mov     cx,003dh
        mov     ax,0901h
        int 10h
add dx,cx
mov ah,02
int 10h
		mov     bx,001eh
        mov     cx,0008h
        mov     ax,0920h
        int 10h
add dx,cx
mov ah,02
int 10h
		mov     bx,001eh
        mov     cx,0001h
        mov     ax,09b3h
        int 10h
;second line end draw





;third line
mov dx,0200h
mov ah,02
int 10h
			mov     bx,001eh
        mov     cx,0001h
        mov     ax,09c0h
        int 10h

		mov ah,02
		mov dx,0201h
		int 10h

        mov     cl,78
        mov     ax,09c4h
        int 10h

		mov ah,02
		add dx,cx
		int 10h

        mov     cl,1
        mov     ax,09d9h
        int 10h
;third line end draw




;second upper line
mov dx,0300h
mov ah,02
int 10h

		mov     bx,001eh
        mov     cx,0001h
        mov     ax,09dah
        int 10h

		mov ah,02
		mov dl,01
		int 10h
        mov     cl,78
        mov     ax,09c4h
        int 10h
		mov ah,02
		add dx,cx
		int 10h
        mov     cl,1
        mov     ax,09bfh
        int 10h
;second upper line end draw



;coin - here comes a new challenge
;do a ascii table (00 to FFh), print it in dec base, exchange the color, print hex number and loop until reach the last colum
mov dx,0400h
mov ah,02
int 10h

		mov     bx,001eh
        mov     cx,0001h
        mov     ax,09b3h
        int 10h

		mov ah,02
		mov dl,01
		int 10h
        mov     cl,78
        mov     ax,0920h
        int 10h
		mov ah,02
		add dx,cx
		int 10h
        mov     cl,1
        mov     ax,09b3h
        int 10h


;last line draw 2
mov dx,1800h
mov ah,02
int 10h
			mov     bx,001eh
        mov     cx,0001h
        mov     ax,09c0h
        int 10h

		mov ah,02
;		mov dx,cx
		mov dl,01h
		int 10h

        mov     cl,78
        mov     ax,09c4h
        int 10h

		mov ah,02
		add dx,cx
;		mov dx,0079
		int 10h
;		mov     bl,1eh
        mov     cl,1
        mov     ax,09d9h
        int 10h
;last line draw 2 end



                mov     ah,00h	;wait user press char
                int 16h
				ret				;in dos .com file you need only a ret to exit, but if you like sure coment this line and uncoment line below
;               int     20h                     ; DOS program terminate

big		endp

intro	db		"Valori dei caratteri visualizzabili - Codici ASCII."


up proc near
	
		mov     bx,001eh				;cor de fundo e do caractere caractere
        mov     cx,0001h	;quantidade de vezes a escrever o caracter
        mov     ax,09dah		;funo mostrar cor, al == caractere
        int 10h

		mov ah,02
		mov dx,0001		;linha coluna
		int 10h
        mov     cl,78	;quantidade de vezes a escrever o caracter
        mov     ax,09c4h		;funo mostrar cor
        int 10h
		mov ah,02
		add dx,cx
		int 10h
        mov     cl,1	;quantidade de vezes a escrever o caracter
        mov     ax,09bfh		;funo mostrar cor
        int 10h

	ret

up endp

down proc near	;dummy unrolled to test
	
			mov     bx,001eh
        mov     cx,0001h
        mov     ax,09c0h
        int 10h

		mov ah,02
;		add dx,cx
		mov dx,0201h
		int 10h

        mov     cl,78
        mov     ax,09c4h
        int 10h

		mov ah,02
		add dx,cx
;		mov dx,0079
		int 10h

;		mov     bl,1eh				;the registers are preserved
        mov     cl,1
        mov     ax,09d9h
        int 10h
	ret
down endp

pos_cursor proc	;working
;bh == line bl == column
	push ax
	push bx
	mov ah,02
	int 10h
	pop bx
	pop ax
	ret
pos_cursor endp

print proc		;working
;al == char to be printed
;bl = HIGH = background color (0 to F) LOW = face color of char (0 to F)
;we are printing only one time - to be implemented in a loop inside your procedure
	push bx
	push cx
	push ax
	mov ah,09		;bios function 9
					;al == char to print
	mov cx,1		;how many times
	int 10h			;call BIOS
	pop ax
	pop cx
	pop bx
	ret
print endp

seg_a		ends
end     big

