seg_a		segment	byte public
		assume	cs:seg_a, ds:seg_a


		org	100h

big		proc	far


;                call    menu
                call setar_modo_video

                call    lookme

                call    cima

                call    linha
                call    cema

start:
                call    espaco

                call    pegue_dig
                xchg    al,ah

                call    hexa
                call    tab
                call    espaco
                xchg    ah,al

                and     ax,00ffh

                mov     dl,al
                call    espaco
                call    tab

                call    mostre_dig
		xor	dl,dl			; Zero register
                call    espaco
                call    tab

                call    binario
                call    espaco
                call    tab

                call    hexa
                call    espaco
                call    tab

                call    decimal
               ; call    asdf

                call    inter

                cmp     al,5ch
                jne     start
                je      finalment


                finalment:

                call    baixo

                call    linha
                call    baixa


                mov     bl,02h
                call    ver_cor

                int     20h                     ; DOS program terminate

big		endp

;
;                              SUBROUTINE
;
menu	proc	near
push	cx
push	bx
push	ax
;call    setar_modo_video
mov	cx,05h
chonk:
mov	al,[berros+bx]

call	escrever_cor
;call    avancar_cursor
inc	bx
loop	chonk
pop	ax
pop	bx
pop	cx
ret
menu	endp


;
;                              SUBROUTINE
;
avancar_cursor  proc    near
push    ax
push    bx
mov     ah,02h
xor     bx,bx
mov     dh,00           ;linha
inc     dl           ;coluna
push    dx
int 10h
pop     dx
pop     bx
pop     ax
ret
avancar_cursor  endp


;
;                              SUBROUTINE
;
escrever_cor    proc near
        push    ax
        push    bx
        push    cx

        mov     cx,0001h
        mov     bl,04h

        mov     ah,09h

        int 10h
        pop     cx
        pop     bx
        pop     ax
        ret

escrever_cor    endp

;
;                              SUBROUTINE
;

setar_modo_video        proc near
        push    ax
        mov     ax,0003h        ;80x25
        int     10h
        pop     ax
        ret
        
setar_modo_video        endp

;
;                              SUBROUTINE
;

decimal         proc    near
		push	cx
		push	si
		push	dx
		push	ax
		xor	cx,cx			; Zero register
		mov	si,0Ah
loc_1:
                xor dx,dx
                div     si                      ; ax,dx rem=dx:ax/reg
		push	dx
		inc	cx
		or	ax,ax			; Zero ?
		jnz	loc_1			; Jump if not zero

locloop_2:
		mov	dx,0
		pop	dx
		add	dx,30h
                mov     bl,0eh
                call    ver_cor
                
                call    mostre_dig
		loop	locloop_2		; Loop if cx > 0
                mov     dx,'d'
                call    mostre_dig
		pop	ax
		pop	dx
		pop	si
		pop	cx
                ret
decimal         endp


;
;                              SUBROUTINE
;

hexa            proc    near
		push	ax
		push	dx
		push	cx
		mov	dl,al
		and	dl,0F0h
		mov	cx,4
		shr	dl,cl			; Shift w/zeros fill
		cmp	dl,0Ah
		jae	loc_3			; Jump if above or =
		add	dl,30h			; '0'
                mov     bl,03h
                call    ver_cor

                call    mostre_dig
		jmp	short loc_4
		db	90h
loc_3:
		add	dl,37h			; '7'
                mov     bl,03h
                call    ver_cor

                call    mostre_dig
loc_4:
		mov	dl,al
		and	dl,0Fh
		cmp	dl,0Ah
		jae	loc_5			; Jump if above or =
		add	dl,30h			; '0'
                mov     bl,03h
                call    ver_cor

                call    mostre_dig
		jmp	short loc_6
		db	90h
loc_5:
		add	dl,37h			; '7'
                mov     bl,03h
                call    ver_cor
                
                call    mostre_dig
loc_6:
		mov	dl,68h			; 'h'
                call    mostre_dig
                pop     cx
		pop	dx
		pop	ax
                ret
hexa           endp


;
;                              SUBROUTINE
;

binario         proc    near
		push	cx
		push	dx
		push	ax
		mov	cx,8

locloop_7:
		mov	dl,0
		rcl	al,1			; Rotate thru carry
		adc	dl,30h			; '0'
                mov     bl,04h
                call    ver_cor

                call    mostre_dig
		loop	locloop_7		; Loop if cx > 0

		mov	dl,62h			; 'b'
                call    mostre_dig
		pop	ax
		pop	dx
		pop	cx
                ret
binario         endp


;
;                              SUBROUTINE
;

pegue_dig       proc    near
                mov     ah,00h
                int 16h
                ret
pegue_dig       endp







;pegue_dig       proc    near
;                mov     ah,1
;                int     21h                     ; DOS Services  ah=function 01h
;                                                ;  get keybd char al, with echo
;                mov     ah,0
;                ret
;pegue_dig       endp
;
;
;
;                              SUBROUTINE
;

mostre_dig      proc    near
		push	ax
		mov	ah,2
		int	21h			; DOS Services  ah=function 02h
						;  display char dl
		pop	ax
                ret
mostre_dig      endp

;
;                              SUBROUTINE
;

tab             proc    near
                push    dx
                mov     dl,09h
                call    mostre_dig
                pop     dx
                ret

tab             endp


;
;                              SUBROUTINE
;

inter           proc    near

                push    dx
                mov     dx,0dh
                call    mostre_dig
                mov     dx,0ah
                call    mostre_dig
                pop     dx
                ret

inter           endp




ver_cor    proc near
        push    ax
        push    bx
        push    cx

        mov     cx,0001h

        mov     ah,09h

        int 10h
        pop     cx
        pop     bx
        pop     ax
        ret

ver_cor    endp


linha   proc    near

push    cx
push    dx
push    bx

mov     cx,78
denovo:
mov     dl,0c4h
                mov     bx,vermelho
                call    ver_cor
call    mostre_dig
loop    denovo
pop     bx
pop     dx
pop     cx
ret

linha   endp




espaco  proc    near
push    dx
push    bx
mov     dl,0b3h
mov     bl,01h
call    ver_cor
call    mostre_dig
pop     bx
pop     dx
ret
espaco  endp

cima    proc    near

push    dx
push    bx

mov     dl,0dah
mov     bl,04h
call    ver_cor
call    mostre_dig
pop     bx
pop     dx

ret
cima    endp




cema    proc    near

push    dx
push    bx

mov     dl,0bfh
mov     bl,04h
call    ver_cor
call    mostre_dig
pop     bx
pop     dx

ret
cema    endp


baixo    proc    near

push    dx
push    bx

mov     dl,0c0h
mov     bl,04h
call    ver_cor
call    mostre_dig
pop     bx
pop     dx

ret
baixo    endp


baixa    proc    near

push    dx
push    bx

mov     dl,0d9h
mov     bl,04h
call    ver_cor
call    mostre_dig
pop     bx
pop     dx

ret
baixa   endp

lookme  proc    near
push    ax
push    dx

mov     dx,offset       intro
mov     ah,09
int 21h
pop     dx
pop     ax

ret
lookme  endp



asdf proc near
push    ax
push    bx
push    dx

mov     ah,02h
xor     bx,bx
mov     dl,80           ;coluna
int 10h
mov     bl,04h
call    ver_cor
mov dl,0b3h
pop     dx
pop     bx
pop     ax

ret
asdf    endp



intro   db      'press \ to get out of this program, hit any keyboard key',0dh,0ah,24h



vermelho   equ      04h

berros  db      'letra'


seg_a		ends
end     big

